# select only older individuals (+65y)

#library(geomtextpath)
library(psych)
library(haven)
library(ggplot2)
library(tidyr)
library(dplyr)
#Function to create original PCA from UKBB data
#FYI, not of use for individual GWAS projects

setwd("/home/fbeyer/UKBB/ukbb-spatial-wmh/analysis")
source("create_PCA.R")
### Perform PCA on TIV-scaled WMH volumes
res_long=read.csv("../res_UKBB_long_individual_N5719.csv")


demographics=read.csv("/isilon/cbib/INSERM_U897/UKBiobank_data/UKBiobank2023_App94113/PhenotypeData/Proteomic/Proteomic_Data.txt.tab", sep="\t")
demographics$pseudonym=paste0("sub.", demographics$f.eid)

res_long_demo=merge(res_long, demographics[,c("pseudonym", "f.21003.0.0")], all.x=T)

## Test only above 65 -> N=598
res_long65=res_long_demo[res_long_demo$f.21003.0.0>=65, ]

pca_UKBB_65=create_PCA(res_long65, dep="WMH_vol_adj", method="pca",nfactors = 2, 
                    rotation="none")
fapar=fa.parallel(pca_UKBB_65[[1]],fa = "pc", n.obs=length(unique(res_long65$pseudonym)))
pca_UKBB_65=create_PCA(res_long65, dep="WMH_vol_adj", method="pca",nfactors = fapar$ncomp, 
                    rotation="oblimin", ncol=ceiling(fapar$ncomp/2))
save(pca_UKBB_65, file="pca_ukbb65.Rdata")

# pcaplot=  pca_UKBB_65[[3]] +
#   theme_bw() +
#   theme(panel.border = element_blank(),
#         axis.text.x = element_text(size=8,
#                                    colour = "black", vjust = 0.05),
#         axis.title.x = element_blank(),
#         axis.title.y = element_blank(),
#         axis.ticks.y=element_blank(),
#         axis.text.y = element_blank(),
#         legend.position = "none",
#         panel.grid.major = element_blank(),
#         strip.text.x = element_text(size = 10,
#                                     margin = margin( b = 1, t = 1)),
#         panel.spacing.x = unit(0.5, "lines"),
#         plot.margin=grid::unit(c(0,0,0,0), "mm"))
# 
#ggsave(pcaplot,
#       file=paste0("Bullseye_UKBB_individiual_N598_age65.png"),
#       width = 10, height=10, unit="cm")

## Test only above 50 -> N=3781
res_long50=res_long_demo[res_long_demo$f.21003.0.0>=50, ]

pca_UKBB_50=create_PCA(res_long50, dep="WMH_vol_adj", method="pca",nfactors = 2, 
                       rotation="none")
fapar=fa.parallel(pca_UKBB_50[[1]],fa = "pc", n.obs=length(unique(res_long50$pseudonym)))
pca_UKBB_50=create_PCA(res_long50, dep="WMH_vol_adj", method="pca",nfactors = fapar$ncomp, 
                       rotation="oblimin", ncol=ceiling(fapar$ncomp/2))
save(pca_UKBB_50, file="pca_ukbb50.Rdata")
# 
# pcaplot=  pca_UKBB_50[[3]] +
#   theme_bw() +
#   theme(panel.border = element_blank(),
#         axis.text.x = element_text(size=8,
#                                    colour = "black", vjust = 0.05),
#         axis.title.x = element_blank(),
#         axis.title.y = element_blank(),
#         axis.ticks.y=element_blank(),
#         axis.text.y = element_blank(),
#         legend.position = "none",
#         panel.grid.major = element_blank(),
#         strip.text.x = element_text(size = 10,
#                                     margin = margin( b = 1, t = 1)),
#         panel.spacing.x = unit(0.5, "lines"),
#         plot.margin=grid::unit(c(0,0,0,0), "mm"))
# # 
# ggsave(pcaplot,
#        file=paste0("Bullseye_UKBB_individiual_N3781_age50.png"),
#        width = 10, height=10, unit="cm")

